	PROGRAM ThinMatrix_Vector_Seriell

! ============================================================
!
!  Exercise 6 - irregular distribution - serial version
!  
! ============================================================
!
!  declarations
!
! ============================================================

	IMPLICIT NONE

	INTEGER, PARAMETER :: N = 500000
	! Size of B(Nx1) C(Nx1) and A(NxN)
	Integer, PARAMETER :: M = 4
	! Number of Elements in each row of A
	! M << N.
	INTEGER, DIMENSION(N, M) :: A
	INTEGER, DIMENSION(N, M) :: Column_Idx
	! Indices for each element in A
	! The column-indices of A are used as
	! row-indices for B.
	INTEGER, DIMENSION(N) :: B, C
	INTEGER :: i, j


! ===============================================
!
! main program
!
! ===============================================


	! Inititialize the elements of A	
	A = 2
	! Initialize B and C
	B = 4
	C = 0
	! Set column indices of all elemensts
	! in A to a value in 1..N
	DO i = 1, N
	  DO j = 1, M
	    Column_Idx(i, j) = MOD (i*j+j, N) + 1
	  END DO
	END DO 

	PRINT *, "Calculating..."
	! Multiplication C = A * B
	DO i = 1, N
	  DO j = 1, M
	    C(i) = C(i) + A(i, j) * B(Column_Idx(i, j))
	  END DO
	END DO
	! Control output
	PRINT *, "Sum: ", SUM(C)

	END PROGRAM ThinMatrix_Vector_Seriell
