	program derivation

! ============================================================
!
!  Exercise 4 - second derivation - serial version
!  
! ============================================================
!
!  declarations
!
! ============================================================

	IMPLICIT NONE

	  INTEGER, PARAMETER :: n = 20
	  INTEGER :: i

	  DOUBLE PRECISION, DIMENSION(0:n) ::  fctn, deriv_2

! ==============================================
!
! main program
!
! ==============================================

! 	    create lookup table

            DO i=0,n		
                fctn(i)=i**3/6.d0
	    END DO

!	    derivate precalculated function
            DO i=2,n
              deriv_2(i) = (fctn(i-2)+fctn(i))-fctn(i-1)*2.d0
            END DO

!	    prints data, first and last value from derivation is invalid
            DO i=2,n
		PRINT *, "f (", i-1, ")=", fctn(i-1) 
		PRINT *, "f'(", i, ")=", deriv_2(i)
		PRINT *, "---"
            END DO
       
	END PROGRAM derivation
