	program derivation

! ============================================================
!
!  Exercise 4 - second derivation - parallel version
!  
! ============================================================
!
!  declarations
!
! ============================================================


	IMPLICIT NONE

	  INTEGER, PARAMETER :: n = 20
	  INTEGER :: i

	  DOUBLE PRECISION, DIMENSION(0:n) ::  fctn, deriv_2

!HPF$ DISTRIBUTE(BLOCK) :: deriv_2, fctn
!HPF$ SHADOW (2:0) :: fctn

! ==============================================
!
! main program
!
! ==============================================

! 	    create lookup table

!HPF$ INDEPENDENT, ON HOME (fctn(i))
            DO i=0,n		
                fctn(i)=i**3/6.d0
	    END DO

!	    derivate precalculated function using cshift
            deriv_2 = (fctn + CSHIFT(fctn, -2)) - CSHIFT(fctn, -1)*2.d0

!	    prints data, first and last value from derivation is invalid
            DO i=2,n
		PRINT *, "f (", i-1, ")=", fctn(i-1) 
		PRINT *, "f'(", i, ")=", deriv_2(i)
		PRINT *, "---"
            END DO
       
	END PROGRAM derivation
